searchData={"items":[{"type":"module","title":"Exqlite","doc":"SQLite3 driver for Elixir.","ref":"Exqlite.html"},{"type":"function","title":"Exqlite.child_spec/1","doc":"","ref":"Exqlite.html#child_spec/1"},{"type":"function","title":"Exqlite.close/3","doc":"","ref":"Exqlite.html#close/3"},{"type":"function","title":"Exqlite.close!/3","doc":"","ref":"Exqlite.html#close!/3"},{"type":"function","title":"Exqlite.execute/4","doc":"","ref":"Exqlite.html#execute/4"},{"type":"function","title":"Exqlite.execute!/4","doc":"","ref":"Exqlite.html#execute!/4"},{"type":"function","title":"Exqlite.prepare/4","doc":"","ref":"Exqlite.html#prepare/4"},{"type":"function","title":"Exqlite.prepare!/4","doc":"","ref":"Exqlite.html#prepare!/4"},{"type":"function","title":"Exqlite.prepare_execute/5","doc":"","ref":"Exqlite.html#prepare_execute/5"},{"type":"function","title":"Exqlite.prepare_execute!/5","doc":"","ref":"Exqlite.html#prepare_execute!/5"},{"type":"function","title":"Exqlite.query/4","doc":"","ref":"Exqlite.html#query/4"},{"type":"function","title":"Exqlite.query!/4","doc":"","ref":"Exqlite.html#query!/4"},{"type":"function","title":"Exqlite.rollback/2","doc":"","ref":"Exqlite.html#rollback/2"},{"type":"function","title":"Exqlite.start_link/1","doc":"See `Exqlite.Connection.connect/1`","ref":"Exqlite.html#start_link/1"},{"type":"function","title":"Exqlite.transaction/3","doc":"","ref":"Exqlite.html#transaction/3"},{"type":"module","title":"Exqlite.Basic","doc":"A very basic API for simple use cases.","ref":"Exqlite.Basic.html"},{"type":"function","title":"Exqlite.Basic.close/1","doc":"","ref":"Exqlite.Basic.html#close/1"},{"type":"function","title":"Exqlite.Basic.disable_load_extension/1","doc":"","ref":"Exqlite.Basic.html#disable_load_extension/1"},{"type":"function","title":"Exqlite.Basic.enable_load_extension/1","doc":"","ref":"Exqlite.Basic.html#enable_load_extension/1"},{"type":"function","title":"Exqlite.Basic.exec/3","doc":"","ref":"Exqlite.Basic.html#exec/3"},{"type":"function","title":"Exqlite.Basic.load_extension/2","doc":"","ref":"Exqlite.Basic.html#load_extension/2"},{"type":"function","title":"Exqlite.Basic.open/1","doc":"","ref":"Exqlite.Basic.html#open/1"},{"type":"function","title":"Exqlite.Basic.rows/1","doc":"","ref":"Exqlite.Basic.html#rows/1"},{"type":"module","title":"Exqlite.Connection","doc":"This module implements connection details as defined in DBProtocol.","ref":"Exqlite.Connection.html"},{"type":"module","title":"Attributes - Exqlite.Connection","doc":"- `db` - The sqlite3 database reference.\n- `path` - The path that was used to open.\n- `transaction_status` - The status of the connection. Can be `:idle` or `:transaction`.","ref":"Exqlite.Connection.html#module-attributes"},{"type":"module","title":"Unknowns - Exqlite.Connection","doc":"- How are pooled connections going to work? Since sqlite3 doesn't allow for\n  simultaneous access. We would need to check if the write ahead log is\n  enabled on the database. We can't assume and set the WAL pragma because the\n  database may be stored on a network volume which would cause potential\n  issues.\n\nNotes:\n  - we try to closely follow structure and naming convention of myxql.\n  - sqlite thrives when there are many small conventions, so we may not implement\n    some strategies employed by other adapters. See https://sqlite.org/np1queryprob.html","ref":"Exqlite.Connection.html#module-unknowns"},{"type":"function","title":"Exqlite.Connection.connect/1","doc":"Initializes the Ecto Exqlite adapter.\n\nFor connection configurations we use the defaults that come with SQLite3, but\nwe recommend which options to choose. We do not default to the recommended\nbecause we don't know what your environment is like.\n\nAllowed options:\n\n  * `:database` - The path to the database. In memory is allowed. You can use\n    `:memory` or `\":memory:\"` to designate that.\n  * `:default_transaction_mode` - one of `deferred` (default), `immediate`,\n    or `exclusive`. If a mode is not specified in a call to `Repo.transaction/2`,\n    this will be the default transaction mode.\n  * `:mode` - use `:readwrite` to open the database for reading and writing\n    , `:readonly` to open it in read-only mode or `[:readonly | :readwrite, :nomutex]`\n    to open it with no mutex mode. `:readwrite` will also create\n    the database if it doesn't already exist. Defaults to `:readwrite`.\n    Note: [:readwrite, :nomutex] is not recommended.\n  * `:journal_mode` - Sets the journal mode for the sqlite connection. Can be\n    one of the following `:delete`, `:truncate`, `:persist`, `:memory`,\n    `:wal`, or `:off`. Defaults to `:delete`. It is recommended that you use\n    `:wal` due to support for concurrent reads. Note: `:wal` does not mean\n    concurrent writes.\n  * `:temp_store` - Sets the storage used for temporary tables. Default is\n    `:default`. Allowed values are `:default`, `:file`, `:memory`. It is\n    recommended that you use `:memory` for storage.\n  * `:synchronous` - Can be `:extra`, `:full`, `:normal`, or `:off`. Defaults\n    to `:normal`.\n  * `:foreign_keys` - Sets if foreign key checks should be enforced or not.\n    Can be `:on` or `:off`. Default is `:on`.\n  * `:cache_size` - Sets the cache size to be used for the connection. This is\n    an odd setting as a positive value is the number of pages in memory to use\n    and a negative value is the size in kilobytes to use. Default is `-2000`.\n    It is recommended that you use `-64000`.\n  * `:cache_spill` - The cache_spill pragma enables or disables the ability of\n    the pager to spill dirty cache pages to the database file in the middle of\n    a transaction. By default it is `:on`, and for most applications, it\n    should remain so.\n  * `:case_sensitive_like`\n  * `:auto_vacuum` - Defaults to `:none`. Can be `:none`, `:full` or\n    `:incremental`. Depending on the database size, `:incremental` may be\n    beneficial.\n  * `:locking_mode` - Defaults to `:normal`. Allowed values are `:normal` or\n    `:exclusive`. See [sqlite documentation][1] for more information.\n  * `:secure_delete` - Defaults to `:off`. If enabled, it will cause SQLite3\n    to overwrite records that were deleted with zeros.\n  * `:wal_auto_check_point` - Sets the write-ahead log auto-checkpoint\n    interval. Default is `1000`. Setting the auto-checkpoint size to zero or a\n    negative value turns auto-checkpointing off.\n  * `:busy_timeout` - Sets the busy timeout in milliseconds for a connection.\n    Default is `2000`.\n  * `:chunk_size` - The chunk size for bulk fetching. Defaults to `50`.\n  * `:key` - Optional key to set during database initialization. This PRAGMA\n    is often used to set up database level encryption.\n  * `:journal_size_limit` - The size limit in bytes of the journal.\n  * `:soft_heap_limit` - The size limit in bytes for the heap limit.\n  * `:hard_heap_limit` - The size limit in bytes for the heap.\n  * `:custom_pragmas` - A list of custom pragmas to set on the connection, for example to configure extensions.\n  * `:load_extensions` - A list of paths identifying extensions to load. Defaults to `[]`.\n    The provided list will be merged with the global extensions list, set on `:exqlite, :load_extensions`.\n    Be aware that the path should handle pointing to a library compiled for the current architecture.\n    Example configuration:\n\n    ```\n      arch_dir =\n        System.cmd(\"uname\", [\"-sm\"])\n        |> elem(0)\n        |> String.trim()\n        |> String.replace(\" \", \"-\")\n        |> String.downcase() # => \"darwin-arm64\"\n\n      config :myapp, arch_dir: arch_dir\n\n      # global\n      config :exqlite, load_extensions: [ \"./priv/sqlite/#{arch_dir}/rotate\" ]\n\n      # per connection in a Phoenix app\n      config :myapp, Myapp.Repo,\n        database: \"path/to/db\",\n        load_extensions: [\n          \"./priv/sqlite/#{arch_dir}/vector0\",\n          \"./priv/sqlite/#{arch_dir}/vss0\"\n        ]\n    ```\n  * `:before_disconnect` - A function to run before disconnect, either a\n    2-arity fun or `{module, function, args}` with the close reason and\n    `t:Exqlite.Connection.t/0` prepended to `args` or `nil` (default: `nil`)\n\nFor more information about the options above, see [sqlite documentation][1]\n\n[1]: https://www.sqlite.org/pragma.html","ref":"Exqlite.Connection.html#connect/1"},{"type":"function","title":"Exqlite.Connection.handle_begin/2","doc":"Begin a transaction.\n\nFor full info refer to sqlite docs: https://sqlite.org/lang_transaction.html\n\nNote: default transaction mode is DEFERRED.","ref":"Exqlite.Connection.html#handle_begin/2"},{"type":"function","title":"Exqlite.Connection.handle_close/3","doc":"Close a query prepared by `handle_prepare/3` with the database. Return\n`{:ok, result, state}` on success and to continue,\n`{:error, exception, state}` to return an error and continue, or\n`{:disconnect, exception, state}` to return an error and disconnect.\n\nThis callback is called in the client process.","ref":"Exqlite.Connection.html#handle_close/3"},{"type":"function","title":"Exqlite.Connection.maybe_put_command/2","doc":"","ref":"Exqlite.Connection.html#maybe_put_command/2"},{"type":"type","title":"Exqlite.Connection.auto_vacuum/0","doc":"","ref":"Exqlite.Connection.html#t:auto_vacuum/0"},{"type":"type","title":"Exqlite.Connection.connection_opt/0","doc":"","ref":"Exqlite.Connection.html#t:connection_opt/0"},{"type":"type","title":"Exqlite.Connection.journal_mode/0","doc":"","ref":"Exqlite.Connection.html#t:journal_mode/0"},{"type":"type","title":"Exqlite.Connection.locking_mode/0","doc":"","ref":"Exqlite.Connection.html#t:locking_mode/0"},{"type":"type","title":"Exqlite.Connection.synchronous/0","doc":"","ref":"Exqlite.Connection.html#t:synchronous/0"},{"type":"type","title":"Exqlite.Connection.t/0","doc":"","ref":"Exqlite.Connection.html#t:t/0"},{"type":"type","title":"Exqlite.Connection.temp_store/0","doc":"","ref":"Exqlite.Connection.html#t:temp_store/0"},{"type":"type","title":"Exqlite.Connection.transaction_mode/0","doc":"","ref":"Exqlite.Connection.html#t:transaction_mode/0"},{"type":"module","title":"Exqlite.Pragma","doc":"Handles parsing extra options for the SQLite connection","ref":"Exqlite.Pragma.html"},{"type":"function","title":"Exqlite.Pragma.auto_vacuum/1","doc":"","ref":"Exqlite.Pragma.html#auto_vacuum/1"},{"type":"function","title":"Exqlite.Pragma.busy_timeout/1","doc":"","ref":"Exqlite.Pragma.html#busy_timeout/1"},{"type":"function","title":"Exqlite.Pragma.cache_size/1","doc":"","ref":"Exqlite.Pragma.html#cache_size/1"},{"type":"function","title":"Exqlite.Pragma.cache_spill/1","doc":"","ref":"Exqlite.Pragma.html#cache_spill/1"},{"type":"function","title":"Exqlite.Pragma.case_sensitive_like/1","doc":"","ref":"Exqlite.Pragma.html#case_sensitive_like/1"},{"type":"function","title":"Exqlite.Pragma.foreign_keys/1","doc":"","ref":"Exqlite.Pragma.html#foreign_keys/1"},{"type":"function","title":"Exqlite.Pragma.journal_mode/1","doc":"","ref":"Exqlite.Pragma.html#journal_mode/1"},{"type":"function","title":"Exqlite.Pragma.locking_mode/1","doc":"","ref":"Exqlite.Pragma.html#locking_mode/1"},{"type":"function","title":"Exqlite.Pragma.secure_delete/1","doc":"","ref":"Exqlite.Pragma.html#secure_delete/1"},{"type":"function","title":"Exqlite.Pragma.synchronous/1","doc":"","ref":"Exqlite.Pragma.html#synchronous/1"},{"type":"function","title":"Exqlite.Pragma.temp_store/1","doc":"","ref":"Exqlite.Pragma.html#temp_store/1"},{"type":"function","title":"Exqlite.Pragma.wal_auto_check_point/1","doc":"","ref":"Exqlite.Pragma.html#wal_auto_check_point/1"},{"type":"module","title":"Exqlite.Query","doc":"Query struct returned from a successfully prepared query.","ref":"Exqlite.Query.html"},{"type":"function","title":"Exqlite.Query.build/1","doc":"","ref":"Exqlite.Query.html#build/1"},{"type":"type","title":"Exqlite.Query.t/0","doc":"","ref":"Exqlite.Query.html#t:t/0"},{"type":"module","title":"Exqlite.Result","doc":"The database results.","ref":"Exqlite.Result.html"},{"type":"function","title":"Exqlite.Result.new/1","doc":"","ref":"Exqlite.Result.html#new/1"},{"type":"type","title":"Exqlite.Result.t/0","doc":"","ref":"Exqlite.Result.html#t:t/0"},{"type":"module","title":"Exqlite.Sqlite3","doc":"The interface to the NIF implementation.","ref":"Exqlite.Sqlite3.html"},{"type":"function","title":"Exqlite.Sqlite3.bind/2","doc":"Resets a prepared statement and binds values to it.\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?, ?, ?, ?, ?\")\n    iex> Sqlite3.bind(stmt, [42, 3.14, \"Alice\", {:blob, <<0, 0, 0>>}, nil])\n    iex> Sqlite3.step(conn, stmt)\n    {:row, [42, 3.14, \"Alice\", <<0, 0, 0>>, nil]}\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?\")\n    iex> Sqlite3.bind(stmt, [42, 3.14, \"Alice\"])\n    ** (ArgumentError) expected 1 arguments, got 3\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?, ?\")\n    iex> Sqlite3.bind(stmt, [42])\n    ** (ArgumentError) expected 2 arguments, got 1\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?\")\n    iex> Sqlite3.bind(stmt, [:erlang.list_to_pid(~c\"<0.0.0>\")])\n    ** (ArgumentError) unsupported type: #PID<0.0.0>","ref":"Exqlite.Sqlite3.html#bind/2"},{"type":"function","title":"Exqlite.Sqlite3.bind/3","doc":"","ref":"Exqlite.Sqlite3.html#bind/3"},{"type":"function","title":"Exqlite.Sqlite3.bind_blob/3","doc":"Binds a blob value to a prepared statement.\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?\")\n    iex> Sqlite3.bind_blob(stmt, 1, <<0, 0, 0>>)\n    :ok","ref":"Exqlite.Sqlite3.html#bind_blob/3"},{"type":"function","title":"Exqlite.Sqlite3.bind_float/3","doc":"Binds a float value to a prepared statement.\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?\")\n    iex> Sqlite3.bind_float(stmt, 1, 3.14)\n    :ok","ref":"Exqlite.Sqlite3.html#bind_float/3"},{"type":"function","title":"Exqlite.Sqlite3.bind_integer/3","doc":"Binds an integer value to a prepared statement.\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?\")\n    iex> Sqlite3.bind_integer(stmt, 1, 42)\n    :ok","ref":"Exqlite.Sqlite3.html#bind_integer/3"},{"type":"function","title":"Exqlite.Sqlite3.bind_null/2","doc":"Binds a null value to a prepared statement.\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?\")\n    iex> Sqlite3.bind_null(stmt, 1)\n    :ok","ref":"Exqlite.Sqlite3.html#bind_null/2"},{"type":"function","title":"Exqlite.Sqlite3.bind_parameter_count/1","doc":"Returns number of SQL parameters in a prepared statement.\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?, ?\")\n    iex> Sqlite3.bind_parameter_count(stmt)\n    2","ref":"Exqlite.Sqlite3.html#bind_parameter_count/1"},{"type":"function","title":"Exqlite.Sqlite3.bind_text/3","doc":"Binds a text value to a prepared statement.\n\n    iex> {:ok, conn} = Sqlite3.open(\":memory:\", [:readonly])\n    iex> {:ok, stmt} = Sqlite3.prepare(conn, \"SELECT ?\")\n    iex> Sqlite3.bind_text(stmt, 1, \"Alice\")\n    :ok","ref":"Exqlite.Sqlite3.html#bind_text/3"},{"type":"function","title":"Exqlite.Sqlite3.changes/1","doc":"Get the number of changes recently.\n\n**Note**: If triggers are used, the count may be larger than expected.\n\nSee: https://sqlite.org/c3ref/changes.html","ref":"Exqlite.Sqlite3.html#changes/1"},{"type":"function","title":"Exqlite.Sqlite3.close/1","doc":"Closes the database and releases any underlying resources.","ref":"Exqlite.Sqlite3.html#close/1"},{"type":"function","title":"Exqlite.Sqlite3.columns/2","doc":"","ref":"Exqlite.Sqlite3.html#columns/2"},{"type":"function","title":"Exqlite.Sqlite3.deserialize/3","doc":"Disconnect from database and then reopen as an in-memory database based on\nthe serialized binary.","ref":"Exqlite.Sqlite3.html#deserialize/3"},{"type":"function","title":"Exqlite.Sqlite3.enable_load_extension/2","doc":"Allow loading native extensions.","ref":"Exqlite.Sqlite3.html#enable_load_extension/2"},{"type":"function","title":"Exqlite.Sqlite3.execute/2","doc":"Executes an sql script. Multiple stanzas can be passed at once.","ref":"Exqlite.Sqlite3.html#execute/2"},{"type":"function","title":"Exqlite.Sqlite3.fetch_all/2","doc":"","ref":"Exqlite.Sqlite3.html#fetch_all/2"},{"type":"function","title":"Exqlite.Sqlite3.fetch_all/3","doc":"","ref":"Exqlite.Sqlite3.html#fetch_all/3"},{"type":"function","title":"Exqlite.Sqlite3.interrupt/1","doc":"Interrupt a long-running query.","ref":"Exqlite.Sqlite3.html#interrupt/1"},{"type":"function","title":"Exqlite.Sqlite3.last_insert_rowid/1","doc":"","ref":"Exqlite.Sqlite3.html#last_insert_rowid/1"},{"type":"function","title":"Exqlite.Sqlite3.multi_step/2","doc":"","ref":"Exqlite.Sqlite3.html#multi_step/2"},{"type":"function","title":"Exqlite.Sqlite3.multi_step/3","doc":"","ref":"Exqlite.Sqlite3.html#multi_step/3"},{"type":"function","title":"Exqlite.Sqlite3.open/2","doc":"Opens a new sqlite database at the Path provided.\n\n`path` can be `\":memory\"` to keep the sqlite database in memory.","ref":"Exqlite.Sqlite3.html#open/2"},{"type":"function","title":"Options - Exqlite.Sqlite3.open/2","doc":"* `:mode` - use `:readwrite` to open the database for reading and writing\n    , `:readonly` to open it in read-only mode or `[:readonly | :readwrite, :nomutex]`\n    to open it with no mutex mode. `:readwrite` will also create\n    the database if it doesn't already exist. Defaults to `:readwrite`.\n    Note: [:readwrite, :nomutex] is not recommended.","ref":"Exqlite.Sqlite3.html#open/2-options"},{"type":"function","title":"Exqlite.Sqlite3.prepare/2","doc":"","ref":"Exqlite.Sqlite3.html#prepare/2"},{"type":"function","title":"Exqlite.Sqlite3.release/2","doc":"Once finished with the prepared statement, call this to release the underlying\nresources.\n\nThis should be called whenever you are done operating with the prepared statement. If\nthe system has a high load the garbage collector may not clean up the prepared\nstatements in a timely manner and causing higher than normal levels of memory\npressure.\n\nIf you are operating on limited memory capacity systems, definitely call this.","ref":"Exqlite.Sqlite3.html#release/2"},{"type":"function","title":"Exqlite.Sqlite3.reset/1","doc":"Resets a prepared statement.\n\nSee: https://sqlite.org/c3ref/reset.html","ref":"Exqlite.Sqlite3.html#reset/1"},{"type":"function","title":"Exqlite.Sqlite3.serialize/2","doc":"Serialize the contents of the database to a binary.","ref":"Exqlite.Sqlite3.html#serialize/2"},{"type":"function","title":"Exqlite.Sqlite3.set_log_hook/1","doc":"Send log messages to a process.\n\nEach time a message is logged in SQLite a message will be sent to the pid provided as the argument.\n\nThe message is of the form: `{:log, rc, message}`, where:\n\n  * `rc` is an integer [result code](https://www.sqlite.org/rescode.html) or an [extended result code](https://www.sqlite.org/rescode.html#extrc)\n  * `message` is a string representing the log message\n\nSee [`SQLITE_CONFIG_LOG`](https://www.sqlite.org/c3ref/c_config_covering_index_scan.html) and\n[\"The Error And Warning Log\"](https://www.sqlite.org/errlog.html) for more details.","ref":"Exqlite.Sqlite3.html#set_log_hook/1"},{"type":"function","title":"Restrictions - Exqlite.Sqlite3.set_log_hook/1","doc":"* Only one pid can listen to the log messages at a time.\n    If this function is called multiple times, only the last pid will\n    receive the notifications","ref":"Exqlite.Sqlite3.html#set_log_hook/1-restrictions"},{"type":"function","title":"Exqlite.Sqlite3.set_update_hook/2","doc":"Send data change notifications to a process.\n\nEach time an insert, update, or delete is performed on the connection provided\nas the first argument, a message will be sent to the pid provided as the second argument.\n\nThe message is of the form: `{action, db_name, table, row_id}`, where:\n\n  * `action` is one of `:insert`, `:update` or `:delete`\n  * `db_name` is a string representing the database name where the change took place\n  * `table` is a string representing the table name where the change took place\n  * `row_id` is an integer representing the unique row id assigned by SQLite","ref":"Exqlite.Sqlite3.html#set_update_hook/2"},{"type":"function","title":"Restrictions - Exqlite.Sqlite3.set_update_hook/2","doc":"* There are some conditions where the update hook will not be invoked by SQLite.\n    See the documentation for [more details](https://www.sqlite.org/c3ref/update_hook.html)\n  * Only one pid can listen to the changes on a given database connection at a time.\n    If this function is called multiple times for the same connection, only the last pid will\n    receive the notifications\n  * Updates only happen for the connection that is opened. For example, there\n    are two connections A and B. When an update happens on connection B, the\n    hook set for connection A will not receive the update, but the hook for\n    connection B will receive the update.","ref":"Exqlite.Sqlite3.html#set_update_hook/2-restrictions"},{"type":"function","title":"Exqlite.Sqlite3.shrink_memory/1","doc":"Causes the database connection to free as much memory as it can. This is\nuseful if you are on a memory restricted system.","ref":"Exqlite.Sqlite3.html#shrink_memory/1"},{"type":"function","title":"Exqlite.Sqlite3.step/2","doc":"","ref":"Exqlite.Sqlite3.html#step/2"},{"type":"function","title":"Exqlite.Sqlite3.transaction_status/1","doc":"","ref":"Exqlite.Sqlite3.html#transaction_status/1"},{"type":"type","title":"Exqlite.Sqlite3.bind_value/0","doc":"","ref":"Exqlite.Sqlite3.html#t:bind_value/0"},{"type":"type","title":"Exqlite.Sqlite3.db/0","doc":"","ref":"Exqlite.Sqlite3.html#t:db/0"},{"type":"type","title":"Exqlite.Sqlite3.open_mode/0","doc":"","ref":"Exqlite.Sqlite3.html#t:open_mode/0"},{"type":"type","title":"Exqlite.Sqlite3.open_opt/0","doc":"","ref":"Exqlite.Sqlite3.html#t:open_opt/0"},{"type":"type","title":"Exqlite.Sqlite3.reason/0","doc":"","ref":"Exqlite.Sqlite3.html#t:reason/0"},{"type":"type","title":"Exqlite.Sqlite3.row/0","doc":"","ref":"Exqlite.Sqlite3.html#t:row/0"},{"type":"type","title":"Exqlite.Sqlite3.statement/0","doc":"","ref":"Exqlite.Sqlite3.html#t:statement/0"},{"type":"module","title":"Exqlite.Sqlite3NIF","doc":"This is the module where all of the NIF entry points reside. Calling this directly\nshould be avoided unless you are aware of what you are doing.","ref":"Exqlite.Sqlite3NIF.html"},{"type":"function","title":"Exqlite.Sqlite3NIF.bind_blob/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#bind_blob/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.bind_float/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#bind_float/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.bind_integer/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#bind_integer/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.bind_null/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#bind_null/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.bind_parameter_count/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#bind_parameter_count/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.bind_text/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#bind_text/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.changes/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#changes/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.close/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#close/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.columns/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#columns/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.deserialize/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#deserialize/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.enable_load_extension/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#enable_load_extension/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.errmsg/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#errmsg/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.errstr/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#errstr/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.execute/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#execute/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.interrupt/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#interrupt/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.last_insert_rowid/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#last_insert_rowid/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.load_nif/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#load_nif/0"},{"type":"function","title":"Exqlite.Sqlite3NIF.multi_step/3","doc":"","ref":"Exqlite.Sqlite3NIF.html#multi_step/3"},{"type":"function","title":"Exqlite.Sqlite3NIF.open/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#open/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.prepare/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#prepare/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.release/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#release/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.reset/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#reset/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.serialize/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#serialize/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.set_log_hook/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#set_log_hook/1"},{"type":"function","title":"Exqlite.Sqlite3NIF.set_update_hook/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#set_update_hook/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.step/2","doc":"","ref":"Exqlite.Sqlite3NIF.html#step/2"},{"type":"function","title":"Exqlite.Sqlite3NIF.transaction_status/1","doc":"","ref":"Exqlite.Sqlite3NIF.html#transaction_status/1"},{"type":"type","title":"Exqlite.Sqlite3NIF.db/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#t:db/0"},{"type":"type","title":"Exqlite.Sqlite3NIF.reason/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#t:reason/0"},{"type":"type","title":"Exqlite.Sqlite3NIF.row/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#t:row/0"},{"type":"type","title":"Exqlite.Sqlite3NIF.statement/0","doc":"","ref":"Exqlite.Sqlite3NIF.html#t:statement/0"},{"type":"exception","title":"Exqlite.Error","doc":"The error emitted from SQLite or a general error with the library.","ref":"Exqlite.Error.html"},{"type":"type","title":"Exqlite.Error.t/0","doc":"","ref":"Exqlite.Error.html#t:t/0"},{"type":"extras","title":"Readme","doc":"# Exqlite\n\n[![Build Status](https://github.com/elixir-sqlite/exqlite/workflows/CI/badge.svg)](https://github.com/elixir-sqlite/exqlite/actions)\n[![Hex Package](https://img.shields.io/hexpm/v/exqlite.svg)](https://hex.pm/packages/exqlite)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/exqlite)\n\nAn Elixir SQLite3 library.\n\nIf you are looking for the Ecto adapter, take a look at the\n[Ecto SQLite3 library][ecto_sqlite3].\n\nDocumentation: https://hexdocs.pm/exqlite\nPackage: https://hex.pm/packages/exqlite","ref":"readme.html"},{"type":"extras","title":"Caveats - Readme","doc":"* Prepared statements are not cached.\n* Prepared statements are not immutable. You must be careful when manipulating\n  statements and binding values to statements. Do not try to manipulate the\n  statements concurrently. Keep it isolated to one process.\n* Simultaneous writing is not supported by SQLite3 and will not be supported\n  here.\n* All native calls are run through the Dirty NIF scheduler.\n* Datetimes are stored without offsets. This is due to how SQLite3 handles date\n  and times. If you would like to store a timezone, you will need to create a\n  second column somewhere storing the timezone name and shifting it when you\n  get it from the database. This is more reliable than storing the offset as\n  `+03:00` as it does not respect daylight savings time.\n* When storing `BLOB` values, you have to use `{:blob, the_binary}`, otherwise\n  it will be interpreted as a string.","ref":"readme.html#caveats"},{"type":"extras","title":"Installation - Readme","doc":"```elixir\ndefp deps do\n  [\n    {:exqlite, \"~> 0.27\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - Readme","doc":"","ref":"readme.html#configuration"},{"type":"extras","title":"Runtime Configuration - Readme","doc":"```elixir\nconfig :exqlite, default_chunk_size: 100\n```\n\n* `default_chunk_size` - The chunk size that is used when multi-stepping when\n  not specifying the chunk size explicitly.","ref":"readme.html#runtime-configuration"},{"type":"extras","title":"Compile-time Configuration - Readme","doc":"In `config/config.exs`,\n\n```elixir\nconfig :exqlite, force_build: false\n```\n\n* `force_build` - Set `true` to opt out of using precompiled artefacts.\n  This option only affects the default configuration. For advanced configuation,\n  this library will always compile natively.","ref":"readme.html#compile-time-configuration"},{"type":"extras","title":"Advanced Configuration - Readme","doc":"","ref":"readme.html#advanced-configuration"},{"type":"extras","title":"Defining Extra Compile Flags - Readme","doc":"You can enable certain features by doing the following:\n\n```bash\nexport EXQLITE_SYSTEM_CFLAGS=-DSQLITE_ENABLE_DBSTAT_VTAB=1\n```\n\nOr you can pass extra environment variables using the Elixir config:\n\n```elixir\nconfig :exqlite,\n  force_build: true,\n  make_env: %{\n    \"EXQLITE_SYSTEM_CFLAGS\" => \"-DSQLITE_ENABLE_DBSTAT_VTAB=1\",\n    \"V\" => \"1\"\n  }\n```","ref":"readme.html#defining-extra-compile-flags"},{"type":"extras","title":"Listing Flags Used For Compilation - Readme","doc":"If you `export V=1` the flags used for compilation will be output to stdout.","ref":"readme.html#listing-flags-used-for-compilation"},{"type":"extras","title":"Using System Installed Libraries - Readme","doc":"This will vary depending on the operating system.\n\n```bash\n# tell exqlite that we wish to use some other sqlite installation. this will prevent sqlite3.c and friends from compiling\nexport EXQLITE_USE_SYSTEM=1\n\n# Tell exqlite where to find the `sqlite3.h` file\nexport EXQLITE_SYSTEM_CFLAGS=-I/usr/include\n\n# tell exqlite which sqlite implementation to use\nexport EXQLITE_SYSTEM_LDFLAGS=-L/lib -lsqlite3\n```\n\nAfter exporting those variables you can then invoke `mix deps.compile`. Note if you\nre-export those values, you will need to recompile the `exqlite` dependency in order to\npickup those changes.","ref":"readme.html#using-system-installed-libraries"},{"type":"extras","title":"Database Encryption - Readme","doc":"As of version 0.9, `exqlite` supports loading database engines at runtime rather than compiling `sqlite3.c` itself.\nThis can be used to support database level encryption via alternate engines such as [SQLCipher](https://www.zetetic.net/sqlcipher/design)\nor the [Official SEE extension](https://www.sqlite.org/see/doc/trunk/www/readme.wiki). Once you have either of those projects installed\non your system, use the following environment variables during compilation:\n\n```bash\n# tell exqlite that we wish to use some other sqlite installation. this will prevent sqlite3.c and friends from compiling\nexport EXQLITE_USE_SYSTEM=1\n\n# Tell exqlite where to find the `sqlite3.h` file\nexport EXQLITE_SYSTEM_CFLAGS=-I/usr/local/include/sqlcipher\n\n# tell exqlite which sqlite implementation to use\nexport EXQLITE_SYSTEM_LDFLAGS=-L/usr/local/lib -lsqlcipher\n```\n\nOnce you have `exqlite` configured, you can use the `:key` option in the database config to enable encryption:\n\n```elixir\nconfig :exqlite, key: \"super-secret'\n```","ref":"readme.html#database-encryption"},{"type":"extras","title":"Usage - Readme","doc":"The `Exqlite.Sqlite3` module usage is fairly straight forward.\n\n```elixir\n# We'll just keep it in memory right now\n{:ok, conn} = Exqlite.Sqlite3.open(\":memory:\")\n\n# Create the table\n:ok = Exqlite.Sqlite3.execute(conn, \"create table test (id integer primary key, stuff text)\")\n\n# Prepare a statement\n{:ok, statement} = Exqlite.Sqlite3.prepare(conn, \"insert into test (stuff) values (?1)\")\n:ok = Exqlite.Sqlite3.bind(conn, statement, [\"Hello world\"])\n\n# Step is used to run statements\n:done = Exqlite.Sqlite3.step(conn, statement)\n\n# Prepare a select statement\n{:ok, statement} = Exqlite.Sqlite3.prepare(conn, \"select id, stuff from test\")\n\n# Get the results\n{:row, [1, \"Hello world\"]} = Exqlite.Sqlite3.step(conn, statement)\n\n# No more results\n:done = Exqlite.Sqlite3.step(conn, statement)\n\n# Release the statement.\n#\n# It is recommended you release the statement after using it to reclaim the memory\n# asap, instead of letting the garbage collector eventually releasing the statement.\n#\n# If you are operating at a high load issuing thousands of statements, it would be\n# possible to run out of memory or cause a lot of pressure on memory.\n:ok = Exqlite.Sqlite3.release(conn, statement)\n```","ref":"readme.html#usage"},{"type":"extras","title":"Using SQLite3 native extensions - Readme","doc":"Exqlite supports loading [run-time loadable SQLite3 extensions](https://www.sqlite.org/loadext.html).\nA selection of precompiled extensions for popular CPU types / architectures is\navailable by installing the [ExSqlean](https://github.com/mindreframer/ex_sqlean)\npackage. This package wraps [SQLean: all the missing SQLite functions](https://github.com/nalgeon/sqlean).\n\n```elixir\nalias Exqlite.Basic\n{:ok, conn} = Basic.open(\"db.sqlite3\")\n:ok = Basic.enable_load_extension(conn)\n\n# load the regexp extension - https://github.com/nalgeon/sqlean/blob/main/docs/re.md\nBasic.load_extension(conn, ExSqlean.path_for(\"re\"))\n\n# run some queries to test the new `regexp_like` function\n{:ok, [[1]], [\"value\"]} = Basic.exec(conn, \"select regexp_like('the year is 2021', ?) as value\", [\"2021\"]) |> Basic.rows()\n{:ok, [[0]], [\"value\"]} = Basic.exec(conn, \"select regexp_like('the year is 2021', ?) as value\", [\"2020\"]) |> Basic.rows()\n\n# prevent loading further extensions\n:ok = Basic.disable_load_extension(conn)\n{:error, %Exqlite.Error{message: \"not authorized\"}, _} = Basic.load_extension(conn, ExSqlean.path_for(\"re\"))\n\n# close connection\nBasic.close(conn)\n```\n\nIt is also possible to load extensions using the `Connection` configuration. For example:\n\n```elixir\narch_dir =\n  System.cmd(\"uname\", [\"-sm\"])\n  |> elem(0)\n  |> String.trim()\n  |> String.replace(\" \", \"-\")\n  |> String.downcase() # => \"darwin-arm64\"\n\nconfig :myapp, arch_dir: arch_dir\n\n# global\nconfig :exqlite, load_extensions: [ \"./priv/sqlite/\\#{arch_dir}/rotate\" ]\n\n# per connection in a Phoenix app\nconfig :myapp, Myapp.Repo,\n  database: \"path/to/db\",\n  load_extensions: [\n    \"./priv/sqlite/\\#{arch_dir}/vector0\",\n    \"./priv/sqlite/\\#{arch_dir}/vss0\"\n  ]\n```\n\nSee [Exqlite.Connection.connect/1](https://hexdocs.pm/exqlite/Exqlite.Connection.html#connect/1)\nfor more information. When using extensions for SQLite3, they must be compiled\nfor the environment you are targeting.","ref":"readme.html#using-sqlite3-native-extensions"},{"type":"extras","title":"Why SQLite3 - Readme","doc":"I needed an Ecto3 adapter to store time series data for a personal project. I\ndidn't want to go through the hassle of trying to setup a postgres database or\nmysql database when I was just wanting to explore data ingestion and some map\nreduce problems.\n\nI also noticed that other SQLite3 implementations didn't really fit my needs. At\nsome point I also wanted to use this with a nerves project on an embedded device\nthat would be resiliant to power outages and still maintain some state that\n`ets` can not afford.","ref":"readme.html#why-sqlite3"},{"type":"extras","title":"Under The Hood - Readme","doc":"We are using the Dirty NIF scheduler to execute the sqlite calls. The rationale\nbehind this is that maintaining each sqlite's connection command pool is\ncomplicated and error prone.","ref":"readme.html#under-the-hood"},{"type":"extras","title":"Compiling NIF for Windows - Readme","doc":"When compiling on Windows, you will need the [Build Tools](https://visualstudio.microsoft.com/downloads/#build-tools-for-visual-studio-2022) or equivalent toolchain. Please make sure you have the correct environment variables, including path to compiler and linker and architecture that matches `erl.exe` (likely x64).\n\nYou may also need to invoke `vcvarsall.bat amd64` _before_ running `mix`.\n\nA guide is available at [guides/windows.md](./guides/windows.md)","ref":"readme.html#compiling-nif-for-windows"},{"type":"extras","title":"Contributing - Readme","doc":"Feel free to check the project out and submit pull requests.\n\n[ecto_sqlite3]:","ref":"readme.html#contributing"},{"type":"extras","title":"Windows users","doc":"# Windows users\n\n> Exqlite uses an [Erlang NIF](https://erlang.org/doc/tutorial/nif.html) under the hood.  \n> Means calling a native implementation in C.\n\nFor Windows users this means compiling Exqlite does not magically just work,  \nin case it's not able to use the precompiled versions of SQLite (using advanced configuration - compile flags).  \nUnder the hood mix will try to compile the library with NMAKE on Windows.  \nFor this, NMAKE and C++ build tools needs to be available.\n\nOf course, using **WSL 2** can be an alternative if things below doesn't work.","ref":"windows.html"},{"type":"extras","title":"Requirements - Windows users","doc":"","ref":"windows.html#requirements"},{"type":"extras","title":"Install Microsoft C++ Build Tools - Windows users","doc":"Download page:  \n[visualstudio.microsoft.com/visual-cpp-build-tools](https://visualstudio.microsoft.com/visual-cpp-build-tools/)\n\nAlternative direct download link:  \n[aka.ms/vs/17/release/vs_buildtools.exe](https://aka.ms/vs/17/release/vs_buildtools.exe)  \n_(aligned with Visual Studio 2022 - version 17)_\n\nYou need to install the **Desktop development with C++** workload with probably the default optional components.","ref":"windows.html#install-microsoft-c-build-tools"},{"type":"extras","title":"Building environment - Windows users","doc":"","ref":"windows.html#building-environment"},{"type":"extras","title":"Start command prompt with necessary environment - Windows users","doc":"> Assuming you are building for Windows x64.\n\nWithin Windows start menu search for:  \nx64 Native Tools Command Prompt\n\nStarting this command prompt all necessary environment variables  \nfor compiling should be ready within the prompt.\n\nReady to run:\n```powershell\nmix deps.compile exqlite\n\n# or\nmix compile\nmix test\n...\n```\n\n**Alternative way to start prompt**\n\n> Assuming you have _latest_ version of Build Tools, aligned with Visual Studio **2022**,  \ninstalled in its default installation path.\n\n```powershell\ncmd /k \"C:\\Program Files (x86)\\Microsoft Visual Studio\\2022\\BuildTools\\VC\\Auxiliary\\Build\\vcvars64.bat\"\n```","ref":"windows.html#start-command-prompt-with-necessary-environment"},{"type":"extras","title":"Visual Studio Code users using ElixirLS - Windows users","doc":"> Assuming you have _latest_ version of Build Tools, aligned with Visual Studio **2022**,  \ninstalled in its default installation path.\n\nStart Visual Studio Code from a PowerShell prompt within your project folder.\n\n```powershell\ncmd /k '\"C:\\Program Files (x86)\\Microsoft Visual Studio\\2022\\BuildTools\\VC\\Auxiliary\\Build\\vcvars64.bat\" && code .'\n```\n\nWith starting Visual Studio Code this way, ElixirLS should work  \nand even your integrated terminal should be aware of the build tools.\n\nProbably make yourself a shortcut for this.\n\n**Integrated terminal only**\n\nWithin your global `settings.json` or your workspace `.vscode\\settings.json` add:\n\n```json\n{\n  \"terminal.integrated.shell.windows\": \"cmd.exe\",\n  \"terminal.integrated.shellArgs.windows\": [\n     \"/k\",\n     \"C:\\\\Program Files (x86)\\\\Microsoft Visual Studio\\\\2022\\\\BuildTools\\\\VC\\\\Auxiliary\\\\Build\\\\vcvars64.bat\"\n  ]\n}\n```","ref":"windows.html#visual-studio-code-users-using-elixirls"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.28.0 - Changelog","doc":"- changed: Update sqlite to `3.48.0`.\n- fixed: Debug build to not fail assert due to passing `module_str` to enif function.","ref":"changelog.html#v0-28-0"},{"type":"extras","title":"v0.27.1 - Changelog","doc":"- changed: Update sqlite to `3.47.1`.","ref":"changelog.html#v0-27-1"},{"type":"extras","title":"v0.27.0 - Changelog","doc":"- changed: Add ability to set `default_transaction_mode` for the connection\n  configuration.","ref":"changelog.html#v0-27-0"},{"type":"extras","title":"v0.26.0 - Changelog","doc":"- changed: Update sqlite to `3.47.0`.\n- changed: Pre-define atoms in NIF.\n- changed: Adds ability to set individual binds and re-implements `bind/3` using\n  the new `bind_*` functions. And also deprecates `bind/3` in favor of `bind/2`\n  since we don't need conn reference anymore.\n- fixed: Pre-compilation steps for ARM.","ref":"changelog.html#v0-26-0"},{"type":"extras","title":"v0.25.0 - Changelog","doc":"- fixed: Handle binding large 64 bit integers better for ARM systems.\n- fixed: Raise `Exqlite.BindError` when an argument fails to be bound.","ref":"changelog.html#v0-25-0"},{"type":"extras","title":"v0.24.2 - Changelog","doc":"- fixed: Add `SQLITE_ENABLE_DBSTAT_VTAB` to windows build.","ref":"changelog.html#v0-24-2"},{"type":"extras","title":"v0.24.1 - Changelog","doc":"- fixed: Pre-compile images for Apple and Windows","ref":"changelog.html#v0-24-1"},{"type":"extras","title":"v0.24.0 - Changelog","doc":"- changed: Update sqlite to `3.46.1`.\n- fixed: Return `:invalid_flags` instead of `:\"invalid flags\"`.\n- fixed: Allow accent characters to be used for opening files.","ref":"changelog.html#v0-24-0"},{"type":"extras","title":"v0.23.0 - Changelog","doc":"- changed: update sqlite to `3.46.0`.","ref":"changelog.html#v0-23-0"},{"type":"extras","title":"v0.22.0 - Changelog","doc":"- changed: update sqlite to `3.45.3`.","ref":"changelog.html#v0-22-0"},{"type":"extras","title":"v0.21.0 - Changelog","doc":"- added: `Exqlite.Sqlite3.interrupt/1` to interrupt long running queries in the background.","ref":"changelog.html#v0-21-0"},{"type":"extras","title":"v0.20.0 - Changelog","doc":"- changed: update sqlite3 to `3.45.2`.\n- changed: use single nif version.\n- changed: use Erlang/OTP 24 (NIF 2.16) for macOS.\n- changed: updated to elixir_make `v0.8.2`.","ref":"changelog.html#v0-20-0"},{"type":"extras","title":"v0.19.0 - Changelog","doc":"- changed: Dropped support for Elixir v1.13.\n- changed: Updated readme documentation.\n- changed: Updated locked dependencies.","ref":"changelog.html#v0-19-0"},{"type":"extras","title":"v0.18.0 - Changelog","doc":"- added: Ability to specify build parameters programatically.\n- changed: Updated sqlite3 to `3.44.2`.","ref":"changelog.html#v0-18-0"},{"type":"extras","title":"v0.17.0 - Changelog","doc":"- changed: Updaetd sqlite3 to `3.44.0`.\n- added: `:before_disconnect` hook.","ref":"changelog.html#v0-17-0"},{"type":"extras","title":"v0.16.2 - Changelog","doc":"- fixed: Precompile support for Windows.","ref":"changelog.html#v0-16-2"},{"type":"extras","title":"v0.16.1 - Changelog","doc":"- fixed: Precompiled binaries for OTP 26. Windows precompiled binaries should work now.","ref":"changelog.html#v0-16-1"},{"type":"extras","title":"v0.16.0 - Changelog","doc":"- added: `set_log_hook`.\n- removed: `utf8.h` as it is not necessary.","ref":"changelog.html#v0-16-0"},{"type":"extras","title":"v0.15.0 - Changelog","doc":"- added: `set_update_hook`.\n- fixed: sqlite extension alignment problem by utilizing `size_t`.\n- changed: Drop support for Elixir `1.12`.\n- changed: Drop support for OTP 23.\n- changed: Updated sqlite3 to `3.43.2`.","ref":"changelog.html#v0-15-0"},{"type":"extras","title":"v0.14.0 - Changelog","doc":"- changed: Updated sqlite3 to `3.43.1`.","ref":"changelog.html#v0-14-0"},{"type":"extras","title":"v0.13.15 - Changelog","doc":"- fixed: allow gnu compiled binaries to be included on the checksum update step.\n- fixed: do not bind atoms that are prefixed with `nil` as `NULL`. https://github.com/elixir-sqlite/exqlite/pull/258","ref":"changelog.html#v0-13-15"},{"type":"extras","title":"v0.13.14 - Changelog","doc":"- fixed: OTP26 and Elixir 1.15 compilation issues.","ref":"changelog.html#v0-13-14"},{"type":"extras","title":"v0.13.13 - Changelog","doc":"- fixed: Check for `null` sqlite db connection.","ref":"changelog.html#v0-13-13"},{"type":"extras","title":"v0.13.12 - Changelog","doc":"- changed: Updated sqlite3 to `3.42.0`.","ref":"changelog.html#v0-13-12"},{"type":"extras","title":"v0.13.11 - Changelog","doc":"- fixed: Wrap include directory with string so it works with the compiler.","ref":"changelog.html#v0-13-11"},{"type":"extras","title":"v0.13.10 - Changelog","doc":"- added: Ability to specify `:load_extensions` for custom sqlite extensions.\n- changed: Updated sqlite3 to `3.41.2`.","ref":"changelog.html#v0-13-10"},{"type":"extras","title":"v0.13.9 - Changelog","doc":"- fixed: Do not free mutex if it is not set.","ref":"changelog.html#v0-13-9"},{"type":"extras","title":"v0.13.8 - Changelog","doc":"- fixed: Handle SEGFAULT when trying to open a database that the application does not have permissions to open.","ref":"changelog.html#v0-13-8"},{"type":"extras","title":"v0.13.7 - Changelog","doc":"- added: precompilation support for musl based libc.\n- changed: Updated sqlite to `3.41.1`.","ref":"changelog.html#v0-13-7"},{"type":"extras","title":"v0.13.6 - Changelog","doc":"- fixed: Error responses from sqlite NIF come back as an atom, the `message` field in `Exqlite.Error` is expected to be a string.","ref":"changelog.html#v0-13-6"},{"type":"extras","title":"v0.13.5 - Changelog","doc":"- changed: Allow `:force_build` to be specified in application configration to allow projects to force build the application rather than use precompiled binaries.","ref":"changelog.html#v0-13-5"},{"type":"extras","title":"v0.13.4 - Changelog","doc":"- changed: Updated sqlite3 to `3.41.0`.","ref":"changelog.html#v0-13-4"},{"type":"extras","title":"v0.13.3 - Changelog","doc":"- added: precompilation support.","ref":"changelog.html#v0-13-3"},{"type":"extras","title":"v0.13.2 - Changelog","doc":"- fixed: `-O2` flag was not being set when compiling binaries in non windows environment.","ref":"changelog.html#v0-13-2"},{"type":"extras","title":"v0.13.1 - Changelog","doc":"- added: `SQLITE_ENABLE_DBSTAT_VTAB=1`.\n- changed: Allow `EXQLITE_SYSTEM_CFLAGS` to be appended to the `CFLAGS` regardless.","ref":"changelog.html#v0-13-1"},{"type":"extras","title":"v0.13.0 - Changelog","doc":"- removed: Remove support for Elixir 1.11\n- added: Support for custom pragmas to be set.\n- changed: Updated sqlite3 to 3.40.1","ref":"changelog.html#v0-13-0"},{"type":"extras","title":"v0.12.0 - Changelog","doc":"- changed: Use `multi_step` for `Repo.stream` calls.\n- added: Ability to use URI for a database path. See [sqlite docs](https://sqlite.org/uri.html). Example: `file:/tmp/database.db?mode=ro`.","ref":"changelog.html#v0-12-0"},{"type":"extras","title":"v0.11.9 - Changelog","doc":"- fixed: `step/2` typespec was specified incorrectly.","ref":"changelog.html#v0-11-9"},{"type":"extras","title":"v0.11.8 - Changelog","doc":"- changed: Updated sqlite3 to 3.40.0","ref":"changelog.html#v0-11-8"},{"type":"extras","title":"v0.11.7 - Changelog","doc":"- fixed: Segfault issue when database connections would time out.","ref":"changelog.html#v0-11-7"},{"type":"extras","title":"v0.11.6 - Changelog","doc":"- changed: Updated sqlite3 to 3.39.4","ref":"changelog.html#v0-11-6"},{"type":"extras","title":"v0.11.5 - Changelog","doc":"- changed: Updated sqlite3 to 3.39.3","ref":"changelog.html#v0-11-5"},{"type":"extras","title":"v0.11.4 - Changelog","doc":"- changed: Use `sqlite3_open_v2`.\n- changed: Expose `:mode`.\n- changed: Removed old macro hack for erlang nifs.","ref":"changelog.html#v0-11-4"},{"type":"extras","title":"v0.11.3 - Changelog","doc":"- changed: Updated sqlite3 to 3.39.2","ref":"changelog.html#v0-11-3"},{"type":"extras","title":"v0.11.2 - Changelog","doc":"- changed: Fix incorrect ordering due to `Enum.reverse/1`.","ref":"changelog.html#v0-11-2"},{"type":"extras","title":"v0.11.1 - Changelog","doc":"- changed: Updated sqlite3 to 3.38.5","ref":"changelog.html#v0-11-1"},{"type":"extras","title":"v0.11.0 - Changelog","doc":"- added: top level interface for `Exqlite` similar to `Postgrex`'s interface.\n- added: optional table protocol support for results.","ref":"changelog.html#v0-11-0"},{"type":"extras","title":"v0.10.3 - Changelog","doc":"- fixed: Improved `fetch_all/4` call speed.","ref":"changelog.html#v0-10-3"},{"type":"extras","title":"v0.10.2 - Changelog","doc":"- changed: Updated sqlite3 to 3.38.\n- revert: change made to Visual Studio 2022 vcvars64.bat","ref":"changelog.html#v0-10-2"},{"type":"extras","title":"v0.10.1 - Changelog","doc":"- fix: path to Visual Studio 2022 vcvars64.bat","ref":"changelog.html#v0-10-1"},{"type":"extras","title":"v0.10.0 - Changelog","doc":"- added: Custom memory allocator for sqlite to leverage erlang's `enif_alloc` functionality. This allows the memory usage to be tracked with the erlang vm usage stats.","ref":"changelog.html#v0-10-0"},{"type":"extras","title":"v0.9.3 - Changelog","doc":"- fixed: `SIGSEGV` issue when a long running query is timed out.","ref":"changelog.html#v0-9-3"},{"type":"extras","title":"v0.9.2 - Changelog","doc":"- added: Ability to set `:journal_size_limit` in bytes.\n- added: Ability to set `:soft_heap_limit` in bytes.\n- added: Ability to set `:hard_heap_limit` in bytes.","ref":"changelog.html#v0-9-2"},{"type":"extras","title":"v0.9.1 - Changelog","doc":"- added: Documentation about compiling with system install sqlite3.\n- fixed: Debug output during `mix compile` process.","ref":"changelog.html#v0-9-1"},{"type":"extras","title":"v0.9.0 - Changelog","doc":"- added: Allow setting `:key` option `PRAGMA` before all other pragmas to allow for use of encrypted sqlite databases.","ref":"changelog.html#v0-9-0"},{"type":"extras","title":"v0.8.7 - Changelog","doc":"- added: Ability to compile exqlite using the system sqlite3 installation as opposed to building from source.","ref":"changelog.html#v0-8-7"},{"type":"extras","title":"v0.8.6 - Changelog","doc":"- changed: Compile SQLite3 with `-DHAVE_USLEEP=1` to allow for more performant concurrent use.","ref":"changelog.html#v0-8-6"},{"type":"extras","title":"v0.8.5 - Changelog","doc":"- changed: Update SQLite from [3.37.0](https://www.sqlite.org/releaselog/3_37_0.html) to [3.37.2](https://sqlite.org/releaselog/3_37_2.html)","ref":"changelog.html#v0-8-5"},{"type":"extras","title":"v0.8.4 - Changelog","doc":"- fixed: Improved typespecs.","ref":"changelog.html#v0-8-4"},{"type":"extras","title":"v0.8.3 - Changelog","doc":"- changed: Compilation output to be less verbose. If more verbosity is desired `V=1 mix compile` will remedy that.\n- changed: When the path to the database does not exist, `mkdir_p` is invoked.","ref":"changelog.html#v0-8-3"},{"type":"extras","title":"v0.8.2 - Changelog","doc":"- fixed: unicode handling when preparing sql statements.","ref":"changelog.html#v0-8-2"},{"type":"extras","title":"v0.8.1 - Changelog","doc":"- fixed: unicode handling when executing sql statements.","ref":"changelog.html#v0-8-1"},{"type":"extras","title":"v0.8.0 - Changelog","doc":"- changed: Updated SQLite from [3.36.0](https://www.sqlite.org/releaselog/3_36_0.html) to [3.37.0](https://www.sqlite.org/releaselog/3_37_0.html).","ref":"changelog.html#v0-8-0"},{"type":"extras","title":"v0.7.9 - Changelog","doc":"- changed: Debug build opt in, instead of opt out. `export DEBUG=yes` before compilation and it will add a `-g` to the compilation process.","ref":"changelog.html#v0-7-9"},{"type":"extras","title":"v0.7.3 - Changelog","doc":"- added: support for static erlang compilation.","ref":"changelog.html#v0-7-3"},{"type":"extras","title":"v0.7.2 - Changelog","doc":"- added: support for android compilation.","ref":"changelog.html#v0-7-2"},{"type":"extras","title":"v0.7.1 - Changelog","doc":"- fixed: segfault on double closing an sqlite connection.","ref":"changelog.html#v0-7-1"},{"type":"extras","title":"v0.7.0 - Changelog","doc":"- added: `Exqlite.Basic` for a simplified interface to utilizing sqlite3.\n- added: ability to load sqlite extension.","ref":"changelog.html#v0-7-0"},{"type":"extras","title":"v0.6.4 - Changelog","doc":"- changed: Updated SQLite from 3.35.5 to [3.36.0](https://www.sqlite.org/releaselog/3_36_0.html)","ref":"changelog.html#v0-6-4"},{"type":"extras","title":"v0.6.3 - Changelog","doc":"- fixed: perceived memory leak for prepared statements not being cleaned up in a timely manner. This would be an issue for systems under a heavy load.","ref":"changelog.html#v0-6-3"},{"type":"extras","title":"v0.6.2 - Changelog","doc":"- changed: Handle only UTC datetime and convert them to iso form without offset.","ref":"changelog.html#v0-6-2"},{"type":"extras","title":"v0.6.1 - Changelog","doc":"- fixed: compilation issue on windows.","ref":"changelog.html#v0-6-1"},{"type":"extras","title":"v0.6.0 - Changelog","doc":"- added: `Exqlite.Sqlite3.serialize/2` to serialize the contents of the database to a binary.\n- added: `Exqlite.Sqlite3.deserialize/3` to load a previously serialized database from a binary.","ref":"changelog.html#v0-6-0"},{"type":"extras","title":"v0.5.11 - Changelog","doc":"- changed: add the relevant sql statement to the Error exception message\n- changed: update SQLite3 amalgamation to [3.35.5](https://sqlite.org/releaselog/3_35_5.html)\n- fixed: issue with update returning nil rows for empty returning result.","ref":"changelog.html#v0-5-11"},{"type":"extras","title":"v0.5.10 - Changelog","doc":"- fixed: `maybe_set_pragma` was comparing upper case and lower case values when it should not matter.","ref":"changelog.html#v0-5-10"},{"type":"extras","title":"v0.5.9 - Changelog","doc":"- changed: Setting the pragma for `Exqlite.Connection` is now a two step process to check what the value is and then set it to the desired value if it is not already the desired value.","ref":"changelog.html#v0-5-9"},{"type":"extras","title":"v0.5.8 - Changelog","doc":"- added: `Exqlite.Error` now has the statement that failed that the error occurred on.","ref":"changelog.html#v0-5-8"},{"type":"extras","title":"v0.5.7 - Changelog","doc":"- changed: Update SQLite3 amalgamation to [3.35.4](https://sqlite.org/releaselog/3_35_4.html)","ref":"changelog.html#v0-5-7"},{"type":"extras","title":"v0.5.6 - Changelog","doc":"- fixed: SQLite3 amalgamation in 0.5.5 being incorrectly downgraded to 3.34.1. Amalgamation is now correctly [3.35.3](https://sqlite.org/releaselog/3_35_3.html).","ref":"changelog.html#v0-5-6"},{"type":"extras","title":"v0.5.5 - Changelog","doc":"- changed: Update SQLite3 amalgamation to version [3.35.3](https://sqlite.org/releaselog/3_35_3.html)","ref":"changelog.html#v0-5-5"},{"type":"extras","title":"v0.5.4 - Changelog","doc":"- fixed: incorrect passing of `chunk_size` to `fetch_all/4`","ref":"changelog.html#v0-5-4"},{"type":"extras","title":"v0.5.3 - Changelog","doc":"- fixed: `:invalid_chunk_size` being emitted by the `DBConnection.execute`","ref":"changelog.html#v0-5-3"},{"type":"extras","title":"v0.5.2 - Changelog","doc":"- added: Guide for Windows users.\n- added: `Exqlite.Sqlite3.multi_step/3` to step through results chunks at a time.\n- added: `default_chunk_size` configuration.","ref":"changelog.html#v0-5-2"},{"type":"extras","title":"v0.5.1 - Changelog","doc":"- changed: Bumped SQLite3 amalgamation to version [3.35.2](https://sqlite.org/releaselog/3_35_2.html)\n- changed: Replaced old references of [github.com/warmwaffles](http://github.com/warmwaffles)","ref":"changelog.html#v0-5-1"},{"type":"extras","title":"v0.5.0 - Changelog","doc":"- removed: `Ecto.Adapters.Exqlite`. Replaced with [Ecto Sqlite3][ecto_sqlite3] library.\n\n\n[ecto_sqlite3]:","ref":"changelog.html#v0-5-0"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}